<?xml version='1.1' encoding='UTF-8'?>
<flow-definition plugin="workflow-job@2.29">
  <actions/>
  <description>OpenShift CI Routing Pipeline</description>
  <displayName>{{ namespace }}/routing-jenkins-pipeline</displayName>
  <keepDependencies>false</keepDependencies>
  <properties>
    <io.fabric8.jenkins.openshiftsync.BuildConfigProjectProperty plugin="openshift-sync@1.0.41">
      <uid>{{ jk_rt_bc.resources[0].metadata.uid }}</uid>
      <namespace>{{ namespace }}</namespace>
      <name>routing-jenkins-pipeline</name>
      <resourceVersion>{{ jk_rt_bc.resources[0].metadata.resourceVersion }}</resourceVersion>
      <buildRunPolicy>Serial</buildRunPolicy>
    </io.fabric8.jenkins.openshiftsync.BuildConfigProjectProperty>
    <com.sonyericsson.jenkins.plugins.bfa.model.ScannerJobProperty plugin="build-failure-analyzer@1.24.0">
      <doNotScan>false</doNotScan>
    </com.sonyericsson.jenkins.plugins.bfa.model.ScannerJobProperty>
    <org.jenkinsci.plugins.workflow.job.properties.DisableConcurrentBuildsJobProperty/>
    <com.dabsquared.gitlabjenkins.connection.GitLabConnectionProperty plugin="gitlab-plugin@1.5.13">
      <gitLabConnection></gitLabConnection>
    </com.dabsquared.gitlabjenkins.connection.GitLabConnectionProperty>
    <org.jenkinsci.plugins.gogs.GogsProjectProperty plugin="gogs-webhook@1.0.15">
      <gogsSecret></gogsSecret>
      <gogsUsePayload>false</gogsUsePayload>
      <gogsBranchFilter></gogsBranchFilter>
    </org.jenkinsci.plugins.gogs.GogsProjectProperty>
    <hudson.plugins.throttleconcurrents.ThrottleJobProperty plugin="throttle-concurrents@2.0.1">
      <maxConcurrentPerNode>0</maxConcurrentPerNode>
      <maxConcurrentTotal>0</maxConcurrentTotal>
      <categories class="java.util.concurrent.CopyOnWriteArrayList"/>
      <throttleEnabled>false</throttleEnabled>
      <throttleOption>project</throttleOption>
      <limitOneJobWithMatchingParams>false</limitOneJobWithMatchingParams>
      <paramsToUseForLimit></paramsToUseForLimit>
      <configVersion>1</configVersion>
    </hudson.plugins.throttleconcurrents.ThrottleJobProperty>
    <org.jenkinsci.plugins.workflow.job.properties.PipelineTriggersJobProperty>
      <triggers>
        <org.jenkinsci.plugins.gwt.GenericTrigger plugin="generic-webhook-trigger@1.62">
          <spec></spec>
          <genericVariables>
            <org.jenkinsci.plugins.gwt.GenericVariable>
              <expressionType>JSONPath</expressionType>
              <key>ref</key>
              <value>$.ref</value>
              <regexpFilter></regexpFilter>
              <defaultValue></defaultValue>
            </org.jenkinsci.plugins.gwt.GenericVariable>
            <org.jenkinsci.plugins.gwt.GenericVariable>
              <expressionType>JSONPath</expressionType>
              <key>after</key>
              <value>$.after</value>
              <regexpFilter></regexpFilter>
              <defaultValue></defaultValue>
            </org.jenkinsci.plugins.gwt.GenericVariable>
            <org.jenkinsci.plugins.gwt.GenericVariable>
              <expressionType>JSONPath</expressionType>
              <key>projectgitlab</key>
	      <value>$.project.git_ssh_url</value>
              <regexpFilter></regexpFilter>
              <defaultValue></defaultValue>
            </org.jenkinsci.plugins.gwt.GenericVariable>
            <org.jenkinsci.plugins.gwt.GenericVariable>
              <expressionType>JSONPath</expressionType>
              <key>projectgitea</key>
	      <value>$.repository.ssh_url</value>
              <regexpFilter></regexpFilter>
              <defaultValue></defaultValue>
            </org.jenkinsci.plugins.gwt.GenericVariable>
          </genericVariables>
          <regexpFilterText></regexpFilterText>
          <regexpFilterExpression></regexpFilterExpression>
          <printPostContent>false</printPostContent>
          <printContributedVariables>false</printContributedVariables>
          <causeString>Received notification for ref $ref</causeString>
	  <token>{{ (jenkins_trigger_token.resources[0].data['password'] | default('')) | b64decode }}</token>
          <silentResponse>false</silentResponse>
        </org.jenkinsci.plugins.gwt.GenericTrigger>
      </triggers>
    </org.jenkinsci.plugins.workflow.job.properties.PipelineTriggersJobProperty>
  </properties>
  <definition class="org.jenkinsci.plugins.workflow.cps.CpsFlowDefinition" plugin="workflow-cps@2.73">
    <script>pipeline {
    agent any
    options { timeout(time: 5, unit: &apos;MINUTES&apos;) }
    parameters {
{% if gitea_api_address | default(False) %}
        string(defaultValue: &apos;{{ gitea_api_address | urlsplit('hostname') }}&apos;, description: &apos;Default Git Repository&apos;, name: &apos;defaultGit&apos;)
{% elif gogs_api_address | default(False) %}
        string(defaultValue: &apos;{{ gogs_api_address | urlsplit('hostname') }}&apos;, description: &apos;Default Git Repository&apos;, name: &apos;defaultGit&apos;)
{% elif gerrit_api_address | default(False) %}
        string(defaultValue: &apos;{{ gerrit_api_address | urlsplit('hostname') }}&apos;, description: &apos;Default Git Repository&apos;, name: &apos;defaultGit&apos;)
{% else %}
        string(defaultValue: &apos;{{ default_git_server | default('github.com') }}&apos;, description: &apos;Default Git Repository&apos;, name: &apos;defaultGit&apos;)
{% endif %}
        string(defaultValue: &apos;yes&apos;, description: &apos;Forces Reloading Pipelines Definition&apos;, name: &apos;doReloadPipeline&apos;)
	string(defaultValue: &apos;ci.{{ root_domain }}&apos;, description: &apos;OpenShift CI Root DNS Record&apos;, name: &apos;rootDomain&apos;)
    }
    triggers {
        GenericTrigger(
                causeString: &apos;Triggered on $ref&apos;,
                genericVariables: [
                        [key: &apos;after&apos;, value: &apos;$.after&apos;],
                        [key: &apos;projectgitlab&apos;, value: &apos;$.project.git_ssh_url&apos;],
                        [key: &apos;projectgitea&apos;, value: &apos;$.repository.ssh_url&apos;],
                        [key: &apos;ref&apos;, value: &apos;$.ref&apos;]
                    ],
                printContributedVariables: true,
                printPostContent: true,
                regexpFilterExpression: &apos;.*&apos;,
                regexpFilterText: &apos;.*&apos;,
                silentResponse: false,
		token: &apos;{{ jenkins_trigger_token }}&apos;
            )
    }
    stages {
        stage(&apos;Parse Notification&apos;) {
            steps {
                script {
                    openshift.withCluster() {
                        openshift.withProject() {
                            def branch     = &quot;master&quot;
                            def exact      = &quot;&quot;
                            def namespace  = &quot;${openshift.project()}&quot;
                            def url        = &quot;&quot;
                            echo &quot;Using project: ${namespace}&quot;
                            try {
                                url = &quot;${projectgitlab}&quot;
                                echo &quot;Notified GitLab repository: ${projectgitlab}&quot;
                            } catch(e) {
                                try {
                                    url = &quot;${projectgitea}&quot;
                                    echo &quot;Notified Gitea/Gogs repository: ${projectgitea}&quot;
                                } catch(e2) {
                                    echo &quot;missing repository info / unsupported notification format&quot;
                                    throw e2
                                }
                            }
                            try {
                                String refs = &quot;${ref}&quot;
                                if (refs != &quot;&quot;) {
                                    println &quot;Found ref: $refs&quot;
                                    String[] arrBranch = refs.split(&quot;/&quot;)
                                    if (arrBranch.size() &gt; 1) { branch = arrBranch[2] }
                                }
                            } catch(e) { echo &quot;Assuming default branch&quot; }
                            try {
                                echo &quot;Notified hash: ${after}&quot;
                                exact = &quot;${after}&quot;
                            } catch(e) {
                                echo &quot;missing hash, assuming ${branch}&quot;
                                exact = &quot;${branch}&quot;
                            }
                            def repoUrl = url.replaceFirst(/(git|git+ssh|ssh|http|https):\/\/((gitea|gogs|git|www-data)@|)/, &quot;&quot;).replaceFirst(/:(2022|2222|3000|443|8080)/, &quot;&quot;)
                            echo &quot;Pulling from: ${repoUrl}#$exact&quot;
                            def repoHost = repoUrl.split(&apos;/&apos;)[0]
                            def repoName = repoUrl.replace(&quot;${repoHost}/&quot;, &quot;&quot;)
                            def component = repoName.replaceFirst(/^.*(docker|s2i)-/, &quot;&quot;).replace(&quot;.git&quot;, &quot;&quot;).replaceAll(&quot;-&quot;, &quot;&quot;)
                            echo &quot;  with repoHost:${repoHost}, repoName:${repoName}, component:${component}&quot;
                            def folder    = &quot;${namespace}-${component}-jenkins-pipeline&quot;
                            def jobName   = &quot;${namespace}/${folder}&quot;
                            def jobParams = [
                                    [$class: &apos;StringParameterValue&apos;, name: &quot;buildBranch&quot;, value: branch],
                                    [$class: &apos;StringParameterValue&apos;, name: &quot;buildHash&quot;, value: exact],
                                    [$class: &apos;StringParameterValue&apos;, name: &quot;buildRepo&quot;, value: repoUrl]
                                ]
                            currentBuild.description = &quot;&quot;&quot;
                            ${repoHost} ${repoName} ${branch}
                            processing ${exact}
                            &quot;&quot;&quot;.stripIndent()
                            try {
                                sh &quot;test -s ${env.JENKINS_HOME}/jobs/${namespace}/jobs/${folder}/config.xml&quot;
                                if (params.doReloadPipeline == &apos;yes&apos;) { throw &quot;forced reload&quot; }
                            } catch(e) {
                                sh &quot;rm -fr tmpocp; mkdir -p tmpocp&quot;
                                def templatePath = &quot;${env.JENKINS_HOME}/jobs/${namespace}/jobs/${namespace}-routing-jenkins-pipeline/workspace/tmpocp${component}${exact}/openshift/ci.yaml&quot;
                                def privateRepo  = false
                                dir (&quot;tmpocp${component}${exact}&quot;) {
                                    try {
                                        withCredentials([string(credentialsId: &quot;git-${repoHost}&quot;, variable: &apos;GIT_TOKEN&apos;)]) {
                                            sh &quot;git config --global http.sslVerify false&quot;
                                            privateRepo = true
                                            echo &quot;cloning ${repoUrl} over https, using ${repoHost} token&quot;
                                            try { git([ branch: &quot;${branch}&quot;, changelog: false, poll: false, url: &quot;https://${GIT_TOKEN}@${repoUrl}&quot; ]) }
                                            catch(e2) {
                                                echo &quot;caught ${e2} - failed cloning ${repoUrl}#${branch}&quot;
                                                sh &quot;cd .. ; rm -fr tmpocp${component}${exact}&quot;
                                                throw e2
                                            }
                                        }
                                    } catch(e1) {
                                        if (privateRepo != true) {
                                            echo &quot;cloning ${repoUrl} over http&quot;
                                            try { git([ branch: &quot;${branch}&quot;, changelog: false, poll: false, url: &quot;http://${repoUrl}&quot; ]) }
                                            catch(e2) {
                                                echo &quot;caught ${e2} - failed cloning ${repoUrl}#${branch}&quot;
                                                sh &quot;cd .. ; rm -fr tmpocp${component}${exact}&quot;
                                                throw e2
                                            }
                                        } else { throw e1 }
                                    }
                                    try {
                                        if (exact != branch) {
                                            echo &quot;checking out to ${exact}&quot;
                                            sh &quot;git checkout ${exact}&quot;
                                        }
                                    } catch(e1) { echo &quot;sticking with ${branch} - ${e1}&quot; }
                                    try { sh &quot;test -s ${templatePath}&quot; }
                                    catch (e1) {
                                        echo &quot;Could not find ${templatePath} in ${repoUrl}#${branch}&quot;
                                        sh &quot;cd .. ; rm -fr tmpocp${component}${exact}&quot;
                                        throw e1
                                    }
                                    try {
                                        echo &quot;Loading Jenkinsfile template from ${templatePath}&quot;
                                        def templateArgs = [ &quot;-f&quot;, &quot;${templatePath}&quot; ]
                                        try {
                                            sh &quot;grep OPENSHIFT_ROUTED_DOMAIN ${templatePath} &gt;/dev/null&quot;
                                            templateArgs.push(&quot;-p&quot;)
                                            templateArgs.push(&quot;OPENSHIFT_ROUTED_DOMAIN=${params.rootDomain}&quot;)
                                        } catch(e2) { &quot;no routed domain param&quot; }
                                        try {
                                            sh &quot;grep GIT_SOURCE_HOST ${templatePath} &gt;/dev/null&quot;
                                            templateArgs.push(&quot;-p&quot;)
                                            templateArgs.push(&quot;GIT_SOURCE_HOST=${params.defaultGit}&quot;)
                                        } catch(e2) { &quot;no git host param&quot; }
                                        def objectsFromTemplate = openshift.process(templateArgs.join(&apos; &apos;))
                                        echo &quot;operation will apply ${objectsFromTemplate.size()} objects&quot;
                                        for (o in objectsFromTemplate) { o.metadata.labels[&quot;jenkins-ci&quot;] = &quot;${namespace}&quot; }
                                        def created = openshift.apply(objectsFromTemplate)
                                        created.withEach { echo &quot;Created ${it.name()} with labels ${it.object().metadata.labels}&quot; }
                                    } catch (e1) {
                                        echo &quot;Failed creating job ${jobName} - ${e1}&quot;
                                        sh &quot;cd .. ; rm -fr tmpocp${component}${exact}&quot;
                                    }
                                }
                                sh &quot;rm -fr tmpocp${component}${exact}&quot;
                            }
                            try { sh &quot;test -s ${env.JENKINS_HOME}/jobs/${namespace}/jobs/${folder}/config.xml&quot; }
                            catch(e) {
                                echo &quot;Could not find job ${jobName}&quot;
                                throw e
                            }
                            try { build job: &quot;${jobName}&quot;, parameters: jobParams, propagate: false, wait: false }
                            catch(e) { echo &quot;${e}&quot; }
                            echo &quot;Scheduled job $jobName&quot;
                        }
                    }
                }
            }
        }
    }
}</script>
    <sandbox>true</sandbox>
  </definition>
  <triggers/>
  <disabled>false</disabled>
</flow-definition>
